Barcode Lib
===========

Barcode Lib es una librera dirigida a los usuarios de FiveWin,
permitir la impresin de Cdigos de barras de varios tipos, sin la
necesidad de utilizar ninguna fuente de letra externa.

Garantas:
==========

Esta lbrera no ofrece garantas de ninguna clase, no aseguro , ni tan
siquiera, que funcione, slo puedo asegurar que ocupa sitio en los
discos :-)).

Si tienes alguna sugerencia, envala a:

                    Cayetano Gmez

                    Email: cayetano@arrakis.es
                    Fidonet 2:345/410.44

                    Tfno +34-07-618-399
                    ( en cristiano : 907 618 399 )

Comandos :
==========

Para code128
------------

    @ <nRow>, <nCol> CODE128  <cCode> ;
                [ MODE <cMode>] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>] ;

    @ <nRow>, <nCol> CM_CODE128  <cCode> ;
                [ MODE <cMode>] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]  ;
    nRow, nCol : Posicion de impresion del Cdigo de barras
        en code128 son pixels, en cm_code128 son centimetros

    cCode : caracteres a imprimir

    oPrint:  Objeto Print, objeto sobre el que imprimir

    cMode : set de caracteres a imprimir

    El code 128 permite la impresion de cdigos muy compactos con rango
    de caracteres entre 0 y 128, en tres sets
        Set A : caracteres entre 0 y 'Z'
        Set B : caracteres entre '0' y '_'
        Set C : modo Solo numrico ( entre '0' y '9' ), pero
        especialmente denso ( aproximadamente la mitas del anterior)

    Si se espicifica un modo 'A', 'B' o 'C' se usar ese modo, en caso
    contrario se determinar el modo automticamente, mezclando, si es
    necesario, los modos.

    Si no se especificica, se usa el modo automtico

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.


Para code 3 de 9
----------------



    @ <nRow>, <nCol> CODE3_9  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;



    @ <nRow>, <nCol> CM_CODE3_9  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;

    nRow, nCol : Posicion de impresion del Cdigo de barras
        en code3_9 son pixels, en cm_code3_9 son centimetros

    cCode : caracteres a imprimir, en el rango :
         '1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%'
        otros caracteres se ignorarn. no es necesario incluir caracter
        de inicio o fin ( el * ) por que es colocado por las rutinas de
        codificacin. Si se usa ChekDigit este ser aadido por las
        rutinas, no es necesario suministrarlo.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    lCkeck : .t. Aadir CheckDigit, .f. No aadir. Por defecto .f. el
        CheckDigit no est contemplado originalmente por las
        definiciones del cdigo, pero est soportado por la mayora de
        los lectores.

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

Para code EAN13
----------------


    @ <nRow>, <nCol> EAN13  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>] ;
                [ BANNER ];
                [ FONT <cFOnt> ]


    @ <nRow>, <nCol> CM_EAN13  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]  ;
                [ BANNER ];
                [ FONT <cFOnt> ]

    ( Si, el de los supermercados !! :-))  )



    nRow, nCol : Posicion de impresion del Cdigo de barras
        en ean13 son pixels, en c_ean13 son centimetros

    cCode : caracteres a imprimir, en el rango '0' a '9'.
        han de ser hasta 12 digitos, si se expresan menos se completarn
        con '0'. No se ha de incluir el checkdigit, que es calculado por
        las rutinas.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

    BANNER : en caso de que se quiera que se imprima el cdigo debajo
    del cdigo de barras, devidamente formateado y en su sitio :-).
    Incluso en vertical y del color de las barras

    cFont : NOMBRE de la fuente que se usar, por defecto ARIAL, el
    tamao, ancho y alto, de la fuente es calculado en funcin al temao
    del cidigo de barras y su orientacin

Para UPC-A
----------
    @ <nRow>, <nCol> UPCA  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>] ;
                [ BANNER ];
                [ FONT <cFOnt> ]



    @ <nRow>, <nCol> CM_UPCA  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]  ;
                [ BANNER ];
                [ FONT <cFOnt> ]

    ( Si, el de los supermercados Americanos !! :-))  )



    nRow, nCol : Posicion de impresion del Cdigo de barras
        en upca son pixels, en c_upca son centimetros

    cCode : caracteres a imprimir, en el rango '0' a '9'.
        han de ser hasta 11 digitos, si se expresan menos se completarn
        con '0'. No se ha de incluir el checkdigit, que es calculado por
        las rutinas.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

    BANNER : en caso de que se quiera que se imprima el cdigo debajo
    del cdigo de barras, devidamente formateado y en su sitio :-).
    Incluso en vertical y del color de las barras

    cFont : NOMBRE de la fuente que se usar, por defecto ARIAL, el
    tamao, ancho y alto, de la fuente es calculado en funcin al temao
    del cidigo de barras y su orientacin

Para EAN-8
----------
    @ <nRow>, <nCol> EAN8  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>] ;
                [ BANNER ];
                [ FONT <cFOnt> ]



    @ <nRow>, <nCol> CM_EAN8  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]  ;
                [ BANNER ];
                [ FONT <cFOnt> ]

    ( Si, el de los paquetes de tabaco !! :-))  )



    nRow, nCol : Posicion de impresion del Cdigo de barras
        en ean8 son pixels, en c_ean8 son centimetros

    cCode : caracteres a imprimir, en el rango '0' a '9'.
        han de ser hasta 7 digitos, si se expresan menos se completarn
        con '0'. No se ha de incluir el checkdigit, que es calculado por
        las rutinas.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

    BANNER : en caso de que se quiera que se imprima el cdigo debajo
    del cdigo de barras, devidamente formateado y en su sitio :-).
    Incluso en vertical y del color de las barras

    cFont : NOMBRE de la fuente que se usar, por defecto ARIAL, el
    tamao, ancho y alto, de la fuente es calculado en funcin al temao
    del cidigo de barras y su orientacin


Para Codabar
----------
    @ <nRow>, <nCol> codabar  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>] ;



    @ <nRow>, <nCol> CM_codabar  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]  ;


    nRow, nCol : Posicion de impresion del Cdigo de barras
        en codabar son pixels, en c_codabar son centimetros

    cCode : caracteres a imprimir, en el conjunto
             0123456789-$:/.+ABCDTN*E
    si bien la rutina no chequea la existencia de los cdigos de
    arranque y parada, el usuario los ha de suministrar. estos son :

        Arranque        Parada
       Ŀ
           A          T      
       Ĵ
           B          N      
       Ĵ
           C          *      
       Ĵ
           D          E      
       

    as si un cdigo comienza por A ha de terminar con T, por ejemplo:

            A12345-34/34$3T
            ^             ^
        que al leerlo dara :
             12345-34/34$3

    oPrint:  Objeto Print, objeto sobre el que imprimir

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.


Para Suplemento 5
-----------------
    @ <nRow>, <nCol> SUP5  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>] ;



    @ <nRow>, <nCol> CM_SUP5  <cCode> ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]  ;
                [ BANNER ];
                [ FONT <cFOnt> ]

    ( Si, el de las numeraciones de las revistas, los que van junto a los
    EAN 13 de las revistas con el numero de volumen )



    nRow, nCol : Posicion de impresion del Cdigo de barras
        en SUP5 son pixels, en c_SUP5 son centimetros

    cCode : caracteres a imprimir, en el rango '0' a '9'.
        han de ser hasta 5 digitos, si se expresan menos se completarn
        con '0'. No se ha de incluir el checkdigit, que es calculado por
        las rutinas.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.


    BANNER : en caso de que se quiera que se imprima el cdigo debajo
    del cdigo de barras, devidamente formateado y en su sitio :-).
    Incluso en vertical y del color de las barras

    cFont : NOMBRE de la fuente que se usar, por defecto ARIAL, el
    tamao, ancho y alto, de la fuente es calculado en funcin al temao
    del cidigo de barras y su orientacin, es decir, sobre el extremo
    superior de las barras.


Industrial 2 de 5
-----------------

    @ <nRow>, <nCol> IND25  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;



    @ <nRow>, <nCol> CM_IND25  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;

    nRow, nCol : Posicion de impresion del Cdigo de barras
        en IND25 son pixels, en cm_IND25 son centimetros

    cCode : caracteres a imprimir, en el rango :
                         '1234567890'
        otros caracteres se ignorarn. Si se usa ChekDigit este ser
        aadido por las rutinas, no es necesario suministrarlo.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    lCkeck : .t. Aadir CheckDigit, .f. No aadir. Por defecto .f. el
        CheckDigit no est contemplado originalmente por las
        definiciones del cdigo, pero est soportado por la mayora de
        los lectores.

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

    Nota: se utiliza una razn 3:1 entre barra gruesa y fina, lo que a
    demostrado ( por la prctica ) ser un buen factor.




Entrelazado 2 de 5
------------------

    @ <nRow>, <nCol> INT25  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;



    @ <nRow>, <nCol> CM_INT25  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;

    nRow, nCol : Posicion de impresion del Cdigo de barras
        en INT25 son pixels, en cm_INT25 son centimetros

    cCode : caracteres a imprimir, en el rango :
                         '1234567890'
        otros caracteres se ignorarn. Si se usa ChekDigit este ser
        aadido por las rutinas, no es necesario suministrarlo.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    lCkeck : .t. Aadir CheckDigit, .f. No aadir. Por defecto .f. el
        CheckDigit no est contemplado originalmente por las
        definiciones del cdigo, pero est soportado por la mayora de
        los lectores.

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

    Nota: se utiliza una razn 3:1 entre barra gruesa y fina, lo que a
    demostrado ( por la prctica ) ser un buen factor.


Matriz 2 de 5
------------------

    @ <nRow>, <nCol> MAT25  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;



    @ <nRow>, <nCol> CM_MAT25  <cCode> ;
                [ <lCheck:CHECK> ] ;
                [ <lVert:VERTICAL> ];
                [ COLOR <nColor> ] ;
                [ WIDTH <nWidth> ] ;
                [ SIZE <nSize> ] ;
                [ OF <oPrint>]   ;

    nRow, nCol : Posicion de impresion del Cdigo de barras
        en MAT25 son pixels, en cm_MAT25 son centimetros

    cCode : caracteres a imprimir, en el rango :
                         '1234567890'
        otros caracteres se ignorarn. Si se usa ChekDigit este ser
        aadido por las rutinas, no es necesario suministrarlo.

    oPrint:  Objeto Print, objeto sobre el que imprimir

    lCkeck : .t. Aadir CheckDigit, .f. No aadir. Por defecto .f. el
        CheckDigit no est contemplado originalmente por las
        definiciones del cdigo, pero est soportado por la mayora de
        los lectores.

    nColor : el color de las Barras.

    lOrientacin : .t. = horizontal (defecto), .f. = vertical

    nWidth := ancho del mdulo, es decir , de la barra ms fina, en
        centmetros. por defecto 0,025 cm.

    nSize := Longitud de las barras ( ya sea en sentido vertical u
    horizontal). Por defecto 1,5 cm.

    Nota: se utiliza una razn 3:1 entre barra gruesa y fina, lo que a
    demostrado ( por la prctica ) ser un buen factor.
-------------------------------------------------------------------------

FUNCIONES
=========
Se estn aadiendo unas funciones para eexportar el check digit ( por
sugerencia de Gabriel Ravarini ). De momento :

- UPC_CHECK( cCode, nLen)
    Calcula el check digit del tipo UPC , cCode es el cdigo ( tipo caracter )
    Y nLen la longitud sobre la que trabaljar ( 11 o 7). Retorna un caracter
    en el rango "0" .. "9".

-EAN13_CHECK( cCode )
    Calcula el CHeck Digit de EAN13, recibe una cadena de caracteres y
    retorna un caracter en el rango "0" .. "9". La cadena es completada
    con zeros por la derecha o truncada si no mide 12 caracteres.



Espero que os guste....


    Si le sacais provecho a esto, por favor comuncamelo a:
    cayetano@arrakis.es

    o mndame una postal a
        Cayetano Gomez
            Jose Maria de Mena,9 Bajo B
            41008 - Sevilla

    Naturalmenta, sujecencias o bugs que podais encontrar mandadmelos y
    veremos que se puede hacer

    En caso de emergencia --- 907 618 399

